"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require("path");

var _lodash = require("lodash.omit");

var _lodash2 = _interopRequireDefault(_lodash);

var _cmsConfig = require("./utils/cms.config.file");

var _cmsConfig2 = _interopRequireDefault(_cmsConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NUXT_CONFIG_KEY = "netlifyCms";
var CMS_CONFIG_KEY = "cmsConfig";
var CMS_CONFIG_FILENAME = "netlify-cms.yml";

// Defaults
var DEFAULTS = {
  adminPath: "admin",
  adminTitle: "Content Manager",
  extensionsDir: "netlify-cms",
  cmsConfig: {
    media_folder: "static/uploads"
  }
};

var ConfigManager = function () {
  function ConfigManager(nuxtOptions, moduleOptions) {
    _classCallCheck(this, ConfigManager);

    this._cmsConfigFile = new _cmsConfig2.default((0, _path.join)(nuxtOptions.rootDir, CMS_CONFIG_FILENAME));

    this._relativeSrcDir = (0, _path.relative)(nuxtOptions.rootDir, nuxtOptions.srcDir);

    this._userOptions = Object.assign({}, nuxtOptions[NUXT_CONFIG_KEY], moduleOptions);

    var options = (0, _lodash2.default)(Object.assign({}, DEFAULTS, this._userOptions), CMS_CONFIG_KEY);
    options.adminPath = options.adminPath.replace(/\/?$/, "/");
    options.extensionsDir = (0, _path.join)(nuxtOptions.srcDir, options.extensionsDir);
    options.buildDir = (0, _path.join)(nuxtOptions.buildDir, "dist", options.adminPath);
    this._config = options;
  }

  _createClass(ConfigManager, [{
    key: "cmsConfigFile",
    get: function get() {
      return this._cmsConfigFile;
    }
  }, {
    key: "config",
    get: function get() {
      return this._config;
    }
  }, {
    key: "cmsConfig",
    get: function get() {
      var config = this.constructor.setConfigPaths(Object.assign({}, DEFAULTS[CMS_CONFIG_KEY], this._cmsConfigFile.config, this._userOptions[CMS_CONFIG_KEY]), this._relativeSrcDir);
      return config;
    }
  }], [{
    key: "setConfigPaths",
    value: function setConfigPaths(configObject, enforcedPath) {
      var newConfig = {
        collections: []
      };

      newConfig.media_folder = (0, _path.join)(enforcedPath, configObject.media_folder);

      if (configObject.collections) {
        configObject.collections.forEach(function (collection) {
          collection.folder && newConfig.collections.push(Object.assign({}, collection, {
            folder: (0, _path.join)(enforcedPath, collection.folder)
          }));
        });
      }

      return Object.assign({}, configObject, newConfig);
    }
  }]);

  return ConfigManager;
}();

exports.default = ConfigManager;